GgetBoundedBuffer subclass: #AbstractStatesGgetBoundedBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Actalk-Synchro-State-Ex'!


!AbstractStatesGgetBoundedBuffer methodsFor: 'default classes'!

activityClass
	"The abstract states associated specification."

	^GgetBoundedBufferAbstractStatesActivity! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

AbstractStatesGgetBoundedBuffer class
	instanceVariableNames: ''!


!AbstractStatesGgetBoundedBuffer class methodsFor: 'example'!

exampleGgetSize: maxSize numberItems: numberItems speedRatio: ratio
	"self exampleGgetSize: 3 numberItems: 8 speedRatio: 1"

	super exampleGgetSize: maxSize numberItems: numberItems speedRatio: ratio! !

AbstractStatesActivity subclass: #BoundedBufferAbstractStatesActivity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Actalk-Synchro-State-Ex'!


!BoundedBufferAbstractStatesActivity methodsFor: 'abstract states'!

empty
	^#(put:)!

full
	^#(get)!

initialAbstractState
	^#empty!

partial
	"Note that we use union of sets (in fact concatenation of arrays) for better modularity.
	See class Get2BoundedBufferAbstractStatesActivity redefinition of #full,
	and consequently implicit redefinition of #partial."

	^(self empty) + (self full)! !

!BoundedBufferAbstractStatesActivity methodsFor: 'state transition'!

nextAbstractStateAfter: selector
	^oself isEmpty
		ifTrue: [#empty]
		ifFalse: [oself isFull
					ifTrue: [#full]
					ifFalse: [#partial]]! !

BoundedBufferAbstractStatesActivity subclass: #Get2BoundedBufferAbstractStatesActivity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Actalk-Synchro-State-Ex'!


!Get2BoundedBufferAbstractStatesActivity methodsFor: 'abstract states'!

full
	^(super full) + #(get2)!

one
	^(self partial) - #(get2)

	"Note that an alternative is: (self empty) + #(get)."! !

!Get2BoundedBufferAbstractStatesActivity methodsFor: 'state transition'!

nextAbstractStateAfter: selector
	^oself isOne
		ifTrue: [#one]
		ifFalse: [super nextAbstractStateAfter: selector]! !

BoundedBufferAbstractStatesActivity subclass: #GgetBoundedBufferAbstractStatesActivity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Actalk-Synchro-State-Ex'!


!GgetBoundedBufferAbstractStatesActivity methodsFor: 'abstract states'!

partialNotAfterPut
	^(self partial) + #(gget)! !

!GgetBoundedBufferAbstractStatesActivity methodsFor: 'state transition'!

nextAbstractStateAfter: selector
	"We check if the bounded buffer is in partial state AND not after a put."
	"Note that the test [contents isFull not] (to make sure that it is partial)
	may be omitted because we may assume that after a non put, the buffer should not be full."

	^(oself isEmpty not and: [selector ~= #put:])
		ifTrue: [#partialNotAfterPut]
		ifFalse: [super nextAbstractStateAfter: selector]! !

IRBoundedBuffer subclass: #AbstractStatesBoundedBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Actalk-Synchro-State-Ex'!


!AbstractStatesBoundedBuffer methodsFor: 'default classes'!

activityClass
	"The abstract states associated specification."

	^BoundedBufferAbstractStatesActivity! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

AbstractStatesBoundedBuffer class
	instanceVariableNames: ''!


!AbstractStatesBoundedBuffer class methodsFor: 'example'!

exampleSize: maxSize numberItems: numberItems speedRatio: ratio
	"self exampleSize: 3 numberItems: 8 speedRatio: 4"
	"self exampleSize: 3 numberItems: 8 speedRatio: 1/4"

	super exampleSize: maxSize numberItems: numberItems speedRatio: ratio! !

Get2BoundedBuffer subclass: #AbstractStatesGet2BoundedBuffer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Actalk-Synchro-State-Ex'!


!AbstractStatesGet2BoundedBuffer methodsFor: 'state predicates'!

isOne
	^contents size = 1! !

!AbstractStatesGet2BoundedBuffer methodsFor: 'default classes'!

activityClass
	"The abstract states associated specification."

	^Get2BoundedBufferAbstractStatesActivity! !
"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

AbstractStatesGet2BoundedBuffer class
	instanceVariableNames: ''!


!AbstractStatesGet2BoundedBuffer class methodsFor: 'example'!

exampleGet2Size: maxSize numberItems: numberItems speedRatio: ratio
	"self exampleGet2Size: 3 numberItems: 8 speedRatio: 2"

	super exampleGet2Size: maxSize numberItems: numberItems speedRatio: ratio! !
